Package com.io7m.jregions.core.parameterized.areas

# Class PAreaYSplitL<S,​T extends PAreaLType<S>>

java.lang.Object
com.io7m.jregions.core.parameterized.areas.PAreaYSplitL<S,​T>

Type Parameters:
  `S` - A phantom type parameter indicating the coordinate space of the area
  `T` - The precise type of area

All Implemented Interfaces:
  `PAreaYSplitLType<S,​T>`

    public final class PAreaYSplitL<S,​T extends PAreaLType<S>>
    extends java.lang.Object
    implements PAreaYSplitLType<S,​T>

An area that has been split via the Y axis.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type | Class | Description
  --- | --- | ---
  `static class` | `PAreaYSplitL.Builder<S,​T extends PAreaLType<S>>` | Builds instances of type `PAreaYSplitL`.

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `static <S,​ T extends PAreaLType<S>> PAreaYSplitL.Builder<S,​T>` | `builder()` | Creates a builder for `PAreaYSplitL`.
  `static <S,​ T extends PAreaLType<S>> PAreaYSplitL<S,​T>` | `copyOf​(PAreaYSplitLType<S,​T> instance)` | Creates an immutable copy of a `PAreaYSplitLType` value.
  `boolean` | `equals​(java.lang.Object another)` | This instance is equal to all instances of `PAreaYSplitL` that have equal attribute values.
  `int` | `hashCode()` | Computes a hash code from attributes: `lower`, `upper`.
  `T` | `lower()` |
  `static <S,​ T extends PAreaLType<S>> PAreaYSplitL<S,​T>` | `of​(T lower, T upper)` | Construct a new immutable `PAreaYSplitL` instance.
  `java.lang.String` | `toString()` | Prints the immutable value `PAreaYSplitL` with attribute values.
  `T` | `upper()` |
  `PAreaYSplitL<S,​T>` | `withLower​(T value)` | Copy the current immutable object by setting a value for the `lower` attribute.
  `PAreaYSplitL<S,​T>` | `withUpper​(T value)` | Copy the current immutable object by setting a value for the `upper` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### lower

    public T lower()
    Specified by:
      `lower` in interface `PAreaYSplitLType<S,​T extends PAreaLType<S>>`
    Returns:
      The lower half

  - ### upper

    public T upper()
    Specified by:
      `upper` in interface `PAreaYSplitLType<S,​T extends PAreaLType<S>>`
    Returns:
      The upper half

  - ### withLower

    public final PAreaYSplitL<S,​T> withLower​(T value)
    Copy the current immutable object by setting a value for the `lower` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for lower
    Returns:
      A modified copy of the `this` object

  - ### withUpper

    public final PAreaYSplitL<S,​T> withUpper​(T value)
    Copy the current immutable object by setting a value for the `upper` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for upper
    Returns:
      A modified copy of the `this` object

  - ### equals

    public boolean equals​(java.lang.Object another)
    This instance is equal to all instances of `PAreaYSplitL` that have equal attribute values.
    Overrides:
      `equals` in class `java.lang.Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `lower`, `upper`.
    Overrides:
      `hashCode` in class `java.lang.Object`
    Returns:
      hashCode value

  - ### toString

    public java.lang.String toString()
    Prints the immutable value `PAreaYSplitL` with attribute values.
    Overrides:
      `toString` in class `java.lang.Object`
    Returns:
      A string representation of the value

  - ### of

    public static <S,​ T extends PAreaLType<S>> PAreaYSplitL<S,​T> of​(T lower, T upper)
    Construct a new immutable `PAreaYSplitL` instance.
    Type Parameters:
      `S` - generic parameter S
      `T` - generic parameter T
    Parameters:
      `lower` - The value for the `lower` attribute
      `upper` - The value for the `upper` attribute
    Returns:
      An immutable PAreaYSplitL instance

  - ### copyOf

    public static <S,​ T extends PAreaLType<S>> PAreaYSplitL<S,​T> copyOf​(PAreaYSplitLType<S,​T> instance)
    Creates an immutable copy of a `PAreaYSplitLType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Type Parameters:
      `S` - generic parameter S
      `T` - generic parameter T
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable PAreaYSplitL instance

  - ### builder

    public static <S,​ T extends PAreaLType<S>> PAreaYSplitL.Builder<S,​T> builder()
    Creates a builder for `PAreaYSplitL`.

         PAreaYSplitL.&lt;S, T&gt;builder()
            .setLower(T) // required lower
            .setUpper(T) // required upper
            .build();

    Type Parameters:
      `S` - generic parameter S
      `T` - generic parameter T
    Returns:
      A new PAreaYSplitL builder